#!/usr/bin/env python2
# -*- coding: utf-8 -*-

#from iViewXAPI import  *            #iViewX library
#from iViewXAPIReturnCodes import * 

from psychopy import visual, core, data, event, logging, gui
from psychopy.constants import *  # things like STARTED, FINISHED
import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import sin, cos, tan, log, log10, pi, average, sqrt, std, deg2rad, rad2deg, linspace, asarray
from numpy.random import random, randint, normal, shuffle
import pygame
import os  # handy system and path functions

# Store info about the experiment session
expName = u'JOLFOKRCJ'  # from the Builder filename that created this script
expInfo = {u'participant': u'', u'counterbalance': u''}
dlg = gui.DlgFromDict(dictionary=expInfo, title=expName)
if dlg.OK == False: core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName

# Setup filename for saving
if not os.path.isdir('data'):
    os.makedirs('data')  # if this fails (e.g. permissions) we will get error
filename = 'data' + os.path.sep + '%s_%s_%s' %(expInfo['expName'], expInfo['participant'], expInfo['counterbalance'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath=None,
    savePickle=True, saveWideText=True,
    dataFileName=filename)
#save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp

# ############################################################## #
# ------------------LAS-begin eyetracking code------------------ #
# ############################################################## #

#set amount of time needed to fixate in microseconds
#tfix=400000
#set radius of tolerance to fixation in pixels
#rfix=100
#fix location-specify on screen coordinates of fixation cross in pixels (0,0) is top left corner of display
#xfix=840
#yfix=525

#--------------LAS--SET UP CONNECTION-------------------#
#res = iViewXAPI.iV_SetLogger(c_int(8), c_char_p('%s_%s_%s.txt' %(expInfo['expName'], expInfo['participant'], expInfo['counterbalance'])))
#res = iViewXAPI.iV_Connect(c_char_p('127.0.0.1'), c_int(4444), c_char_p('127.0.0.1'), c_int(5555))
#if res != 1:
#    HandleError(res)
#    exit(0)
#    

#res = iViewXAPI.iV_GetSystemInfo(byref(systemData))
#print "iV_GetSystemInfo: " + str(res)
#print "Samplerate: " + str(systemData.samplerate)
#print "iViewX Verion: " + str(systemData.iV_MajorVersion) + "." + str(systemData.iV_MinorVersion) + "." + str(systemData.iV_Buildnumber)
#print "iViewX API Verion: " + str(systemData.API_MajorVersion) + "." + str(systemData.API_MinorVersion) + "." + str(systemData.API_Buildnumber)


# ---------------------------------------------
#---- configure and start calibration
# ---------------------------------------------

#calibrationData = CCalibration(5, 1, 1, 0, 1, 255, 10, 2, 15, b"")

#while accuracyData.deviationLX>.75 or accuracyData.deviationLY>.75:
#    res = iViewXAPI.iV_SetupCalibration(byref(calibrationData))
#    print "iV_SetupCalibration " + str(res)
#    res = iViewXAPI.iV_Calibrate()
#    print "iV_Calibrate " + str(res)

#    res = iViewXAPI.iV_Validate()
#    print "iV_Validate " + str(res)

#    res = iViewXAPI.iV_GetAccuracy(byref(accuracyData),1)
#    print "deviationX " + str(accuracyData.deviationLX) + " deviationY " + str(accuracyData.deviationLY)
#    logMessage = 'deviationX: %s deviationY: %s' %(str(accuracyData.deviationLX), str(accuracyData.deviationLY))
#    iViewXAPI.iV_Log(c_char_p(str(logMessage)))
#    print logMessage


# ############################################################## #
# ------------------LAS-END EYETRACKING CODE-------------------- #
# ############################################################## #

# Setup the Window
win = visual.Window(size=(1680,1050), pos=[0,0], fullscr=True, screen=1, allowGUI=False, allowStencil=False,
    monitor=u'testMonitor', color=[-1,-1,-1], colorSpace=u'rgb',
    blendMode=u'avg',
    units=u'pix')

# Initialize components for Routine "beginCheck"
beginCheckClock = core.Clock()
text_99 = visual.TextStim(win=win, ori=0, name='text_99',
    text=u'Press any key',    font=u'Arial',
    pos=[0, 50], height=55, wrapWidth=1615,
    color=u'black', colorSpace=u'rgb', opacity=1,
    depth=0.0)


# Initialize components for Routine "beginStudy"
beginStudyClock = core.Clock()
text_13 = visual.TextStim(win=win, ori=0, name='text_13',
    text=u'Ready to start the study round?',    font=u'Arial',
    pos=[0, 50], height=55, wrapWidth=1615,
    color=u'white', colorSpace=u'rgb', opacity=1,
    depth=0.0)
text_14 = visual.TextStim(win=win, ori=0, name='text_14',
    text='<<Press the Spacebar to Continue>>',    font='Arial',
    pos=[0, -460], height=40, wrapWidth=1312,
    color='white', colorSpace='rgb', opacity=1,
    depth=-2.0)


# Initialize components for Routine "Scene"
SceneClock = core.Clock()
sceneBorder = visual.GratingStim(win=win, name='sceneBorder',units=u'pix', 
    tex=None, mask=None,
    ori=0, pos=[0, 0], size=[1060,805], sf=None, phase=0.0,
    color=[1,1,1], colorSpace='rgb', opacity=1,
    texRes=128, interpolate=False)
scenePic = visual.PatchStim(win=win, name='scenePic',units=u'pix', 
    tex='sin', mask=None,
    ori=0, pos=[0, 0], size=[1050,795], sf=None, phase=0.0,
    color=[1,1,1], colorSpace='rgb', opacity=1,
    texRes=128, interpolate=False)

# Initialize components for Routine "Fixation"
FixationClock = core.Clock()
fixationCross = visual.TextStim(win=win, ori=0, name='fixationCross',
    text=u'+',    font=u'Arial',
    pos=[0, 0], height=40, wrapWidth=None,
    color=u'white', colorSpace=u'rgb', opacity=1,
    depth=0.0)

# Initialize components for Routine "Scene_Face"
Scene_FaceClock = core.Clock()
sceneBorder2 = visual.GratingStim(win=win, name='sceneBorder2',units=u'pix', 
    tex=None, mask=None,
    ori=0, pos=[0, 0], size=[1060,805], sf=None, phase=0.0,
    color=[1,1,1], colorSpace=u'rgb', opacity=1,
    texRes=128, interpolate=True, depth=0.0)
scenePic2 = visual.PatchStim(win=win, name='scenePic2',units=u'pix', 
    tex='sin', mask=None,
    ori=0, pos=[0, 0], size=[1050,795], sf=None, phase=0.0,
    color=[1,1,1], colorSpace=u'rgb', opacity=1,
    texRes=128, interpolate=True, depth=-1.0)
faceBorder = visual.GratingStim(win=win, name='faceBorder',units=u'pix', 
    tex=None, mask=None,
    ori=0, pos=[0, 0], size=[346, 346], sf=None, phase=0.0,
    color=[0,0,0], colorSpace=u'rgb', opacity=1,
    texRes=128, interpolate=True, depth=-2.0)
studyFace = visual.PatchStim(win=win, name='studyFace',units=u'pix', 
    tex='sin', mask=None,
    ori=0, pos=[0, 0], size=[336,336], sf=None, phase=0.0,
    color=[1,1,1], colorSpace=u'rgb', opacity=1,
    texRes=128, interpolate=True, depth=-3.0)

# Initialize components for Routine "JOL"
JOLClock = core.Clock()
JOLRating = visual.TextStim(win=win, ori=0, name='JOLRating',
    text=u'                 Will you remember that this face goes with this scene?\n\n0%   10%   20%   30%   40%   50%   60%   70%   80%   90%   100%\nDefinitely Will NOT                                                             Definitely Will\nRemember                                                                          Remember',    font=u'Arial',
    pos=[0, 0], height=50, wrapWidth=1640,
    color=u'white', colorSpace=u'rgb', opacity=1,
    depth=0.0)

# Initialize components for Routine "endStudyBlock"
endStudyBlockClock = core.Clock()
text = visual.TextStim(win=win, ori=0, name='text',
    text=u'You have completed this study round.\n\nGood job so far!\n\nPlease alert the experimenter.',    font=u'Arial',
    pos=[0, 0], height=50, wrapWidth=1615,
    color=u'white', colorSpace=u'rgb', opacity=1,
    depth=0.0)

# Initialize components for Routine "beginTest"
beginTestClock = core.Clock()
text_15 = visual.TextStim(win=win, ori=0, name='text_15',
    text=u'Ready to start the test round?',    font=u'Arial',
    pos=[0, 66], height=50, wrapWidth=1615,
    color=u'white', colorSpace=u'rgb', opacity=1,
    depth=0.0)
text_16 = visual.TextStim(win=win, ori=0, name='text_16',
    text='<<Press the Spacebar to Continue>>',    font='Arial',
    pos=[0, -460], height=40, wrapWidth=1312,
    color='white', colorSpace='rgb', opacity=1,
    depth=-2.0)

# Initialize components for Routine "TestScene"
TestSceneClock = core.Clock()
sceneBorderTest = visual.GratingStim(win=win, name='sceneBorderTest',units=u'pix', 
    tex=None, mask=None,
    ori=0, pos=[0, 0], size=[1060,805], sf=None, phase=0.0,
    color=[1,1,1], colorSpace=u'rgb', opacity=1,
    texRes=128, interpolate=True, depth=0.0)
scenePicTest = visual.PatchStim(win=win, name='scenePicTest',units=u'pix', 
    tex='sin', mask=None,
    ori=0, pos=[0, 0], size=[1050,795], sf=None, phase=0.0,
    color=[1,1,1], colorSpace=u'rgb', opacity=1,
    texRes=128, interpolate=True, depth=-1.0)

# Initialize components for Routine "FOK"
FOKClock = core.Clock()
FOKrating = visual.TextStim(win=win, ori=0, name='FOKrating',
    text=u'               Will you remember the correct face?\n\n0%   10%   20%   30%   40%   50%   60%   70%   80%   90%   100%\nDefinitely Will NOT                                                             Definitely WILL\nRemember                                                                          Remember',    font=u'Arial',
    pos=[0, 0], height=50, wrapWidth=1640,
    color=u'white', colorSpace=u'rgb', opacity=1,
    depth=0.0)

# Initialize components for Routine "Fixation"
FixationClock = core.Clock()
fixationCross = visual.TextStim(win=win, ori=0, name='fixationCross',
    text=u'+',    font=u'Arial',
    pos=[0, 0], height=40, wrapWidth=None,
    color=u'white', colorSpace=u'rgb', opacity=1,
    depth=0.0)

# Initialize components for Routine "Scene_3Faces"
Scene_3FacesClock = core.Clock()
sceneBorder3 = visual.GratingStim(win=win, name='sceneBorder3',units='pix', 
    tex=None, mask=None,
    ori=0, pos=[0, 0], size=[1060,805], sf=None, phase=0.0,
    color=[1,1,1], colorSpace='rgb', opacity=1,
    texRes=128, interpolate=True, depth=0.0)
scenePic3 = visual.PatchStim(win=win, name='scenePic3',units=u'pix', 
    tex='sin', mask=None,
    ori=0, pos=[0, 0], size=[1050,795], sf=None, phase=0.0,
    color=[1,1,1], colorSpace=u'rgb', opacity=1,
    texRes=128, interpolate=True, depth=-1.0)
faceBorder1 = visual.GratingStim(win=win, name='faceBorder1',units='pix', 
    tex=None, mask=None,
    ori=0, pos=[-172, 172], size=[346, 346], sf=None, phase=0.0,
    color=[0,0,0], colorSpace='rgb', opacity=1,
    texRes=128, interpolate=True, depth=-2.0)
faceBorder2 = visual.GratingStim(win=win, name='faceBorder2',units='pix', 
    tex=None, mask=None,
    ori=0, pos=[172, 172], size=[346, 346], sf=None, phase=0.0,
    color=[0,0,0], colorSpace='rgb', opacity=1,
    texRes=128, interpolate=True, depth=-3.0)
faceBorder3 = visual.GratingStim(win=win, name='faceBorder3',units='pix', 
    tex=None, mask=None,
    ori=0, pos=[0, -172], size=[346, 346], sf=None, phase=0.0,
    color=[0,0,0], colorSpace='rgb', opacity=1,
    texRes=128, interpolate=True, depth=-4.0)
testFace1 = visual.PatchStim(win=win, name='testFace1',units=u'pix', 
    tex='sin', mask=None,
    ori=0, pos=[-172, 172], size=[336, 336], sf=None, phase=0.0,
    color=[1,1,1], colorSpace=u'rgb', opacity=1,
    texRes=128, interpolate=True, depth=-5.0)
recogQuestion = visual.TextStim(win=win, ori=0, name='recogQuestion',
    text='Which face belongs with this scene?',    font='Arial',
    pos=[0, -460], height=50, wrapWidth=1600,
    color='white', colorSpace='rgb', opacity=1,
    depth=-7.0)
patch = visual.PatchStim(win=win, name='patch',units=u'pix', 
    tex='sin', mask=None,
    ori=0, pos=[172, 172], size=[336, 336], sf=None, phase=0.0,
    color=[1,1,1], colorSpace=u'rgb', opacity=1,
    texRes=128, interpolate=False, depth=-8.0)
patch_2 = visual.PatchStim(win=win, name='patch_2',
    tex='sin', mask=None,
    ori=0, pos=[0, -172], size=[336, 336], sf=None, phase=0.0,
    color=[1,1,1], colorSpace=u'rgb', opacity=1,
    texRes=128, interpolate=False, depth=-9.0)

# Initialize components for Routine "RCJ"
RCJClock = core.Clock()
confRating = visual.TextStim(win=win, ori=0, name='confRating',
    text=u'                        Did you chose the correct face?\n\n0%   10%   20%   30%   40%   50%   60%   70%   80%   90%   100%\nDid NOT Choose                                                        Definitely Chose\nCorrectly                                                                                Correctly',    font=u'Arial',
    pos=[0, 0], height=50, wrapWidth=1640,
    color=u'white', colorSpace=u'rgb', opacity=1,
    depth=0.0)

# Initialize components for Routine "endTestBlock"
endTestBlockClock = core.Clock()
text_8 = visual.TextStim(win=win, ori=0, name='text_8',
    text=u'You have completed this test round.\n\nGood job!\n\nPlease alert the experimenter.',    font=u'Arial',
    pos=[0, 0], height=50, wrapWidth=1600,
    color=u'white', colorSpace=u'rgb', opacity=1,
    depth=0.0)

# Initialize components for Routine "end"
endClock = core.Clock()
text_7 = visual.TextStim(win=win, ori=0, name='text_7',
    text=u'You have completed the experiment!\n\nThank you so much for your participation!',    font=u'Arial',
    pos=[0, 0], height=50, wrapWidth=1600,
    color=u'white', colorSpace=u'rgb', opacity=1,
    depth=0.0)

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 


# ############################################################## #
# ----------------------BEGIN BLOCK LOOP------------------------ #
# ############################################################## #

# set up handler to look after randomisation of conditions etc
blockLoop = data.TrialHandler(nReps=1, method=u'random',
    extraInfo=expInfo, originPath=None,
    trialList=data.importConditions(u'blockfile.xlsx'),
    seed=None, name='blockLoop')
thisExp.addLoop(blockLoop)  # add the loop to the experiment
thisBlockLoop = blockLoop.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb=thisBlockLoop.rgb)
if thisBlockLoop != None:
    for paramName in thisBlockLoop.keys():
        exec(paramName + '= thisBlockLoop.' + paramName)

for thisBlockLoop in blockLoop:
    currentLoop = blockLoop
    # abbreviate parameter names if possible (e.g. rgb = thisBlockLoop.rgb)
    if thisBlockLoop != None:
        for paramName in thisBlockLoop.keys():
            exec(paramName + '= thisBlockLoop.' + paramName)
    
    #------Prepare to start Routine "beginStudy"-------
    t = 0
    beginStudyClock.reset()  # clock 
    frameN = -1
    # update component parameters for each repeat
    key_resp_10 = event.BuilderKeyResponse()  # create an object of type KeyResponse
    key_resp_10.status = NOT_STARTED
    # keep track of which components have finished
    beginStudyComponents = []
    beginStudyComponents.append(text_13)
    beginStudyComponents.append(key_resp_10)
    beginStudyComponents.append(text_14)
    for thisComponent in beginStudyComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    #-------Start Routine "beginStudy"-------
    continueRoutine = True
    while continueRoutine:
        # get current time
        t = beginStudyClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text_13* updates
        if t >= 0.0 and text_13.status == NOT_STARTED:
            # keep track of start time/frame for later
            text_13.tStart = t  # underestimates by a little under one frame
            text_13.frameNStart = frameN  # exact frame index
            text_13.setAutoDraw(True)
        
        # *key_resp_10* updates
        if t >= 0.0 and key_resp_10.status == NOT_STARTED:
            # keep track of start time/frame for later
            key_resp_10.tStart = t  # underestimates by a little under one frame
            key_resp_10.frameNStart = frameN  # exact frame index
            key_resp_10.status = STARTED
            # keyboard checking is just starting
            event.clearEvents(eventType='keyboard')
        if key_resp_10.status == STARTED:
            theseKeys = event.getKeys(keyList=['space'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                # a response ends the routine
                continueRoutine = False
        
        # *text_14* updates
        if t >= 0.0 and text_14.status == NOT_STARTED:
            # keep track of start time/frame for later
            text_14.tStart = t  # underestimates by a little under one frame
            text_14.frameNStart = frameN  # exact frame index
            text_14.setAutoDraw(True)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineTimer.reset()  # if we abort early the non-slip timer needs reset
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in beginStudyComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    #--------------LAS--START RECORDING-------------------#
    #iViewXAPI.iV_StartRecording()
    #msg = '%s_%s%s' %("Begin Recording",thisBlockLoop['studyblock'],".bmp")
    #iViewXAPI.iV_SendImageMessage(c_char_p(str(msg)))
    #print msg
    
    #-------Ending Routine "beginStudy"-------
    for thisComponent in beginStudyComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
            
    # ############################################################## #
    # ----------------------BEGING STUDY LOOP----------------------- #
    # ############################################################## #
    
    # set up handler to look after randomisation of conditions etc
    studyTrials = data.TrialHandler(nReps=1, method=u'random', 
        extraInfo=expInfo, originPath=None,
        trialList=data.importConditions(studyblock),
        seed=None, name='studyTrials')
    thisExp.addLoop(studyTrials)  # add the loop to the experiment
    thisStudyTrial = studyTrials.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb=thisStudyTrial.rgb)
    if thisStudyTrial != None:
        for paramName in thisStudyTrial.keys():
            exec(paramName + '= thisStudyTrial.' + paramName)
    
    for thisStudyTrial in studyTrials:
        currentLoop = studyTrials
        # abbreviate parameter names if possible (e.g. rgb = thisStudyTrial.rgb)
        if thisStudyTrial != None:
            for paramName in thisStudyTrial.keys():
                exec(paramName + '= thisStudyTrial.' + paramName)
        
        #------Prepare to start Routine "Scene"-------
        t = 0
        SceneClock.reset()  # clock 
        frameN = -1
        routineTimer.add(3.500000)
        
        # update component parameters for each repeat
        # ########################LAS-segregate trials#################
        #iViewXAPI.iV_SendImageMessage(c_char_p(str("StudyScene.bmp")))
        scenePic.setTex("Backgrounds/"+Scene)
        # keep track of which components have finished
        SceneComponents = []
        SceneComponents.append(sceneBorder)
        SceneComponents.append(scenePic)
        for thisComponent in SceneComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        #-------Start Routine "Scene"-------
        continueRoutine = True
        while continueRoutine and routineTimer.getTime() > .0:
            # get current time
            t = SceneClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            
            # *sceneBorder* updates
            if t >= 0.5 and sceneBorder.status == NOT_STARTED:
                # keep track of start time/frame for later
                sceneBorder.tStart = t  # underestimates by a little under one frame
                sceneBorder.frameNStart = frameN  # exact frame index
                sceneBorder.setAutoDraw(True)
            elif sceneBorder.status == STARTED and t >= (0.0 + (3.5-win.monitorFramePeriod*0.75)): #most of one frame period left
                sceneBorder.setAutoDraw(False)
            
            # *scenePic* updates
            if t >= 0.5 and scenePic.status == NOT_STARTED:
                # keep track of start time/frame for later
                scenePic.tStart = t  # underestimates by a little under one frame
                scenePic.frameNStart = frameN  # exact frame index
                scenePic.setAutoDraw(True)
            elif scenePic.status == STARTED and t >= (0.0 + (3.5-win.monitorFramePeriod*0.75)): #most of one frame period left
                scenePic.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineTimer.reset()  # if we abort early the non-slip timer needs reset
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in SceneComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            #event.clearEvents()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        #-------Ending Routine "Scene"-------
        for thisComponent in SceneComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        
        
        #------Prepare to start Routine "Fixation"-------
        t = 0
        FixationClock.reset()  # clock 
        frameN = -1
        
        # update component parameters for each repeat
        # ########################LAS-segregate trials#################
        #iViewXAPI.iV_SendImageMessage(c_char_p(str("Fixation.bmp")))
        
        # keep track of which components have finished
        FixationComponents = []
        FixationComponents.append(fixationCross)
        for thisComponent in FixationComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        #-------Start Routine "Fixation"-------
        continueRoutine = True
        while continueRoutine:
            # get current time
            t = FixationClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            
            # update/draw components on each frame
            #res = iViewXAPI.iV_GetSample(byref(sampleData))
            #iViewXAPI.iV_GetEvent(byref(eventData))
            
            #if res == 1:
            #    xdiff=sampleData.leftEye.gazeX-xfix
            #    ydiff=sampleData.leftEye.gazeY-yfix
            #    tmp = (xdiff**2+ ydiff**2)
            #    distfix=pow(tmp, 0.5)
            
            # *fixationCross* updates
            if t >= 0.0 and fixationCross.status == NOT_STARTED:
                # keep track of start time/frame for later
                fixationCross.tStart = t  # underestimates by a little under one frame
                fixationCross.frameNStart = frameN  # exact frame index
                fixationCross.setAutoDraw(True)
            elif fixationCross.status==STARTED and t>.5:
                fixationCross.setAutoDraw(False)
                continueRoutine=False
            #tmp = (xdiff**2+ ydiff**2)
            
            
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineTimer.reset()  # if we abort early the non-slip timer needs reset
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in FixationComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        #-------Ending Routine "Fixation"-------
        for thisComponent in FixationComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        
        #------Prepare to start Routine "Scene_Face"-------
        t = 0
        Scene_FaceClock.reset()  # clock 
        frameN = -1
        routineTimer.add(4.000000)
        # update component parameters for each repeat
        # ########################LAS-segregate trials#################
        #iViewXAPI.iV_SendImageMessage(c_char_p(str("StudyFace.bmp")))
        scenePic2.setTex("Backgrounds/"+Scene)
        studyFace.setTex("Faces/"+Face)
        # keep track of which components have finished
        Scene_FaceComponents = []
        Scene_FaceComponents.append(sceneBorder2)
        Scene_FaceComponents.append(scenePic2)
        Scene_FaceComponents.append(faceBorder)
        Scene_FaceComponents.append(studyFace)
        for thisComponent in Scene_FaceComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        #-------Start Routine "Scene_Face"-------
        continueRoutine = True
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = Scene_FaceClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *sceneBorder2* updates
            if t >= 0.0 and sceneBorder2.status == NOT_STARTED:
                # keep track of start time/frame for later
                sceneBorder2.tStart = t  # underestimates by a little under one frame
                sceneBorder2.frameNStart = frameN  # exact frame index
                sceneBorder2.setAutoDraw(True)
            elif sceneBorder2.status == STARTED and t >= (0.0 + (4-win.monitorFramePeriod*0.75)): #most of one frame period left
                sceneBorder2.setAutoDraw(False)
            
            # *scenePic2* updates
            if t >= 0.0 and scenePic2.status == NOT_STARTED:
                # keep track of start time/frame for later
                scenePic2.tStart = t  # underestimates by a little under one frame
                scenePic2.frameNStart = frameN  # exact frame index
                scenePic2.setAutoDraw(True)
            elif scenePic2.status == STARTED and t >= (0.0 + (4-win.monitorFramePeriod*0.75)): #most of one frame period left
                scenePic2.setAutoDraw(False)
            
            # *faceBorder* updates
            if t >= 0.0 and faceBorder.status == NOT_STARTED:
                # keep track of start time/frame for later
                faceBorder.tStart = t  # underestimates by a little under one frame
                faceBorder.frameNStart = frameN  # exact frame index
                faceBorder.setAutoDraw(True)
            elif faceBorder.status == STARTED and t >= (0.0 + (4-win.monitorFramePeriod*0.75)): #most of one frame period left
                faceBorder.setAutoDraw(False)
            
            # *studyFace* updates
            if t >= 0.0 and studyFace.status == NOT_STARTED:
                # keep track of start time/frame for later
                studyFace.tStart = t  # underestimates by a little under one frame
                studyFace.frameNStart = frameN  # exact frame index
                studyFace.setAutoDraw(True)
            elif studyFace.status == STARTED and t >= (0.0 + (4-win.monitorFramePeriod*0.75)): #most of one frame period left
                studyFace.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineTimer.reset()  # if we abort early the non-slip timer needs reset
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in Scene_FaceComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        #-------Ending Routine "Scene_Face"-------
        for thisComponent in Scene_FaceComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        
        #------Prepare to start Routine "JOL"-------
        t = 0
        JOLClock.reset()  # clock 
        frameN = -1
        routineTimer.add(5.000000)

        # update component parameters for each repeat
        # ########################LAS-segregate trials#################
        #iViewXAPI.iV_SendImageMessage(c_char_p(str("JOLRating.bmp")))
        JOLResponse = event.BuilderKeyResponse()  # create an object of type KeyResponse
        JOLResponse.status = NOT_STARTED
        # keep track of which components have finished
        JOLComponents = []
        JOLComponents.append(JOLRating)
        JOLComponents.append(JOLResponse)
        for thisComponent in JOLComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        #-------Start Routine "JOLRating"-------
        continueRoutine = True
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = JOLClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *fitQuestion* updates
            if t >= 0.0 and JOLRating.status == NOT_STARTED:
                # keep track of start time/frame for later
                JOLRating.tStart = t  # underestimates by a little under one frame
                JOLRating.frameNStart = frameN  # exact frame index
                JOLRating.setAutoDraw(True)
            elif JOLRating.status == STARTED and t >= (0.0 + (5-win.monitorFramePeriod*0.75)): #most of one frame period left
                JOLRating.setAutoDraw(False)
            
            # *JOLResponse* updates
            if t >= 0.0 and JOLResponse.status == NOT_STARTED:
                # keep track of start time/frame for later
                JOLResponse.tStart = t  # underestimates by a little under one frame
                JOLResponse.frameNStart = frameN  # exact frame index
                JOLResponse.status = STARTED
                # keyboard checking is just starting
                JOLResponse.clock.reset()  # now t=0
                event.clearEvents(eventType='keyboard')
            elif JOLResponse.status == STARTED and t >= (0.0 + (5-win.monitorFramePeriod*0.75)): #most of one frame period left
                JOLResponse.status = STOPPED
            if JOLResponse.status == STARTED:
                theseKeys = event.getKeys(keyList=['quoteleft', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0'])
                
                # check for quit:
                if "escape" in theseKeys:
                    endExpNow = True
                if len(theseKeys) > 0:  # at least one key was pressed
                    JOLResponse.keys = theseKeys[-1]  # just the last key pressed
                    JOLResponse.rt = JOLResponse.clock.getTime()
                    # a response ends the routine
                    continueRoutine = False
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineTimer.reset()  # if we abort early the non-slip timer needs reset
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in JOLComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
                

        #-------Ending Routine "JOL"-------
        for thisComponent in JOLComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # check responses
        if JOLResponse.keys in ['', [], None]:  # No response was made
           JOLResponse.keys=None
        # store data for studyTrials (TrialHandler)
        studyTrials.addData('JOLResponse.keys',JOLResponse.keys)
        if JOLResponse.keys != None:  # we had a response
            studyTrials.addData('JOLResponse.rt', JOLResponse.rt)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'studyTrials'
    # ########################LAS-segregate trials#################
    #iViewXAPI.iV_PauseRecording()
    #iViewXAPI.iV_SendImageMessage(c_char_p(str("Finished Study Block Pause Recording")))
    
    # get names of stimulus parameters
    if studyTrials.trialList in ([], [None], None):  params = []
    else:  params = studyTrials.trialList[0].keys()
    # save data for this loop
    studyTrials.saveAsExcel(filename + '.xlsx', sheetName='studyTrials',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    
    #------Prepare to start Routine "endStudyBlock"-------
    
    t = 0
    endStudyBlockClock.reset()  # clock 
    frameN = -1
    # update component parameters for each repeat
    key_resp_2 = event.BuilderKeyResponse()  # create an object of type KeyResponse
    key_resp_2.status = NOT_STARTED
    # keep track of which components have finished
    endStudyBlockComponents = []
    endStudyBlockComponents.append(text)
    endStudyBlockComponents.append(key_resp_2)
    for thisComponent in endStudyBlockComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    #-------Start Routine "endStudyBlock"-------
    continueRoutine = True
    while continueRoutine:
        # get current time
        t = endStudyBlockClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
            
        # *text* updates
        if t >= 0.0 and text.status == NOT_STARTED:
            # keep track of start time/frame for later
            text.tStart = t  # underestimates by a little under one frame
            text.frameNStart = frameN  # exact frame index
            text.setAutoDraw(True)
        
        # *key_resp_2* updates
        if t >= 0.0 and key_resp_2.status == NOT_STARTED:
            # keep track of start time/frame for later
            key_resp_2.tStart = t  # underestimates by a little under one frame
            key_resp_2.frameNStart = frameN  # exact frame index
            key_resp_2.status = STARTED
            # keyboard checking is just starting
            event.clearEvents(eventType='keyboard')
        if key_resp_2.status == STARTED:
            theseKeys = event.getKeys(keyList=['q'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineTimer.reset()  # if we abort early the non-slip timer needs reset
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in endStudyBlockComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
        else:  # this Routine was not non-slip safe so reset non-slip timer
            routineTimer.reset()
    
    #-------Ending Routine "endStudyBlock"-------
    for thisComponent in endStudyBlockComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    
    #------Prepare to start Routine "beginTest"-------
    
    t = 0
    beginTestClock.reset()  # clock 
    frameN = -1
    # update component parameters for each repeat
    key_resp_11 = event.BuilderKeyResponse()  # create an object of type KeyResponse
    key_resp_11.status = NOT_STARTED
    # keep track of which components have finished
    beginTestComponents = []
    beginTestComponents.append(text_15)
    beginTestComponents.append(key_resp_11)
    beginTestComponents.append(text_16)
    for thisComponent in beginTestComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    #-------Start Routine "beginTest"-------
    continueRoutine = True
    while continueRoutine:
        # get current time
        t = beginTestClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text_15* updates
        if t >= 0.0 and text_15.status == NOT_STARTED:
            # keep track of start time/frame for later
            text_15.tStart = t  # underestimates by a little under one frame
            text_15.frameNStart = frameN  # exact frame index
            text_15.setAutoDraw(True)
        
        # *key_resp_11* updates
        if t >= 0.0 and key_resp_11.status == NOT_STARTED:
            # keep track of start time/frame for later
            key_resp_11.tStart = t  # underestimates by a little under one frame
            key_resp_11.frameNStart = frameN  # exact frame index
            key_resp_11.status = STARTED
            # keyboard checking is just starting
            event.clearEvents(eventType='keyboard')
        if key_resp_11.status == STARTED:
            theseKeys = event.getKeys(keyList=['space'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                # a response ends the routine
                continueRoutine = False
        
        # *text_16* updates
        if t >= 0.0 and text_16.status == NOT_STARTED:
            # keep track of start time/frame for later
            text_16.tStart = t  # underestimates by a little under one frame
            text_16.frameNStart = frameN  # exact frame index
            text_16.setAutoDraw(True)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineTimer.reset()  # if we abort early the non-slip timer needs reset
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in beginTestComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
        else:  # this Routine was not non-slip safe so reset non-slip timer
            routineTimer.reset()
    
    #iViewXAPI.iV_ContinueRecording(c_char_p('BeginTestBlock'))
    # ########################LAS-segregate trials#################
    #iViewXAPI.iV_SendImageMessage(c_char_p(str("Begin Test Block Conitinue Recording")))
    #use counterbalance to determine which test list is used
    if expInfo['counterbalance']=='A':
        testblock=testblockA
    elif expInfo['counterbalance']=='B':
        testblock=testblockB
    elif expInfo['counterbalance']=='C':
        testblock=testblockC
    #-------Ending Routine "beginTest"-------
    for thisComponent in beginTestComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    
    # set up handler to look after randomisation of conditions etc
    testTrials = data.TrialHandler(nReps=1, method=u'random', 
        extraInfo=expInfo, originPath=None,
        trialList=data.importConditions(testblock),
        seed=None, name='testTrials')
    thisExp.addLoop(testTrials)  # add the loop to the experiment
    thisTestTrial = testTrials.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb=thisTestTrial.rgb)
    if thisTestTrial != None:
        for paramName in thisTestTrial.keys():
            exec(paramName + '= thisTestTrial.' + paramName)
    
    for thisTestTrial in testTrials:
        currentLoop = testTrials
        # abbreviate parameter names if possible (e.g. rgb = thisTestTrial.rgb)
        if thisTestTrial != None:
            for paramName in thisTestTrial.keys():
                exec(paramName + '= thisTestTrial.' + paramName)
                
        #------Prepare to start Routine "TestScene"-------
        t = 0
        TestSceneClock.reset()  # clock 
        frameN = -1
        routineTimer.add(3.500000)
        # update component parameters for each repeat
        # ########################LAS-segregate trials#################
        #iViewXAPI.iV_SendImageMessage(c_char_p(str("TestScene.bmp")))
        scenePicTest.setTex("Backgrounds/"+SceneA)
        # keep track of which components have finished
        TestSceneComponents = []
        TestSceneComponents.append(sceneBorderTest)
        TestSceneComponents.append(scenePicTest)
        for thisComponent in TestSceneComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        #-------Start Routine "TestScene"-------
        continueRoutine = True
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = TestSceneClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *sceneBorderTest* updates
            if t >= 0.5 and sceneBorderTest.status == NOT_STARTED:
                # keep track of start time/frame for later
                sceneBorderTest.tStart = t  # underestimates by a little under one frame
                sceneBorderTest.frameNStart = frameN  # exact frame index
                sceneBorderTest.setAutoDraw(True)
            elif sceneBorderTest.status == STARTED and t >= (0.0 + (3.5-win.monitorFramePeriod*0.75)): #most of one frame period left
                sceneBorderTest.setAutoDraw(False)
            
            # *scenePicTest* updates
            if t >= 0.5 and scenePicTest.status == NOT_STARTED:
                # keep track of start time/frame for later
                scenePicTest.tStart = t  # underestimates by a little under one frame
                scenePicTest.frameNStart = frameN  # exact frame index
                scenePicTest.setAutoDraw(True)
            elif scenePicTest.status == STARTED and t >= (0.0 + (3.5-win.monitorFramePeriod*0.75)): #most of one frame period left
                scenePicTest.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineTimer.reset()  # if we abort early the non-slip timer needs reset
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in TestSceneComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        #-------Ending Routine "TestScene"-------
        for thisComponent in TestSceneComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        
        #------Prepare to start Routine "FOK"-------
        
        t = 0
        FOKClock.reset()  # clock 
        frameN = -1
        routineTimer.add(5.000000)

        # update component parameters for each repeat
        # ########################LAS-segregate trials#################
        #iViewXAPI.iV_SendImageMessage(c_char_p(str("FOK.bmp")))
        FOKresp = event.BuilderKeyResponse()  # create an object of type KeyResponse
        FOKresp.status = NOT_STARTED
        # keep track of which components have finished
        FOKComponents = []
        FOKComponents.append(FOKrating)
        FOKComponents.append(FOKresp)
        for thisComponent in FOKComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        #-------Start Routine "FOK"-------
        continueRoutine = True
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = FOKClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            # *FOKrating* updates
            if t >= 0.0 and FOKrating.status == NOT_STARTED:
                # keep track of start time/frame for later
                FOKrating.tStart = t  # underestimates by a little under one frame
                FOKrating.frameNStart = frameN  # exact frame index
                FOKrating.setAutoDraw(True)
            elif FOKrating.status == STARTED and t >= (0.0 + (5-win.monitorFramePeriod*0.75)): #most of one frame period left
                FOKrating.setAutoDraw(False)
            
            # *FOKresp* updates
            if t >= 0.0 and FOKresp.status == NOT_STARTED:
                # keep track of start time/frame for later
                FOKresp.tStart = t  # underestimates by a little under one frame
                FOKresp.frameNStart = frameN  # exact frame index
                FOKresp.status = STARTED
                # keyboard checking is just starting
                FOKresp.clock.reset()  # now t=0
                event.clearEvents(eventType='keyboard')
            elif FOKresp.status == STARTED and t >= (0.0 + (5-win.monitorFramePeriod*0.75)): #most of one frame period left
                FOKresp.status = STOPPED
            if FOKresp.status == STARTED:
                theseKeys = event.getKeys(keyList=['quoteleft', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0'])
                
                # check for quit:
                if "escape" in theseKeys:
                    endExpNow = True
                if len(theseKeys) > 0:  # at least one key was pressed
                    FOKresp.keys = theseKeys[-1]  # just the last key pressed
                    FOKresp.rt = FOKresp.clock.getTime()
                    # a response ends the routine
                    continueRoutine = False
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineTimer.reset()  # if we abort early the non-slip timer needs reset
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in FOKComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        #-------Ending Routine "FOK"-------
        for thisComponent in FOKComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # check responses
        if FOKresp.keys in ['', [], None]:  # No response was made
           FOKresp.keys=None
        # store data for testTrials (TrialHandler)
        testTrials.addData('FOKresp.keys',FOKresp.keys)
        if FOKresp.keys != None:  # we had a response
            testTrials.addData('FOKresp.rt', FOKresp.rt)
        
        #------Prepare to start Routine "Fixation"-------
        t = 0
        FixationClock.reset()  # clock 
        frameN = -1
        # update component parameters for each repeat
        # ########################LAS-segregate trials#################
        #iViewXAPI.iV_SendImageMessage(c_char_p(str("Fixation.bmp")))
        
        # keep track of which components have finished
        FixationComponents = []
        FixationComponents.append(fixationCross)
        for thisComponent in FixationComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        #-------Start Routine "Fixation"-------
        continueRoutine = True
        while continueRoutine:
            # get current time
            t = FixationClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            
            # update/draw components on each frame
            #res = iViewXAPI.iV_GetSample(byref(sampleData))
            #tmp_fix=iViewXAPI.iV_GetEvent(byref(eventData))
        
            #if res == 1:
            #    xdiff=sampleData.leftEye.gazeX-xfix
            #    ydiff=sampleData.leftEye.gazeY-yfix
            #    tmp = (xdiff**2+ ydiff**2)
            #    distfix=pow(tmp, 0.5)
            
            # *fixationCross* updates
            if t >= 0.0 and fixationCross.status == NOT_STARTED:
                # keep track of start time/frame for later
                fixationCross.tStart = t  # underestimates by a little under one frame
                fixationCross.frameNStart = frameN  # exact frame index
                fixationCross.setAutoDraw(True)
            elif fixationCross.status==STARTED and t>.5: #rfix>distfix and eventData.duration>tfix:
                fixationCross.setAutoDraw(False)
                continueRoutine=False
            #tmp = (xdiff**2+ ydiff**2)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineTimer.reset()  # if we abort early the non-slip timer needs reset
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in FixationComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        #-------Ending Routine "Fixation"-------
        for thisComponent in FixationComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        
        #------Prepare to start Routine "Scene_3Faces"-------
        t = 0
        Scene_3FacesClock.reset()  # clock 
        frameN = -1
        routineTimer.add(6.000000)
        # update component parameters for each repeat
        # ########################LAS-segregate trials#################
        #iViewXAPI.iV_SendImageMessage(c_char_p(str("Recognition.bmp")))
        scenePic3.setTex("Backgrounds/"+SceneA)
        testFace1.setTex("Faces/"+Face1)
        recogResponse = event.BuilderKeyResponse()  # create an object of type KeyResponse
        recogResponse.status = NOT_STARTED
        patch.setTex("Faces/"+Face2)
        patch_2.setTex("Faces/"+Face3)
        # keep track of which components have finished
        Scene_3FacesComponents = []
        Scene_3FacesComponents.append(sceneBorder3)
        Scene_3FacesComponents.append(scenePic3)
        Scene_3FacesComponents.append(faceBorder1)
        Scene_3FacesComponents.append(faceBorder2)
        Scene_3FacesComponents.append(faceBorder3)
        Scene_3FacesComponents.append(testFace1)
        Scene_3FacesComponents.append(recogResponse)
        Scene_3FacesComponents.append(recogQuestion)
        Scene_3FacesComponents.append(patch)
        Scene_3FacesComponents.append(patch_2)
        for thisComponent in Scene_3FacesComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        #-------Start Routine "Scene_3Faces"-------
        continueRoutine = True
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = Scene_3FacesClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *sceneBorder3* updates
            if t >= 0.0 and sceneBorder3.status == NOT_STARTED:
                # keep track of start time/frame for later
                sceneBorder3.tStart = t  # underestimates by a little under one frame
                sceneBorder3.frameNStart = frameN  # exact frame index
                sceneBorder3.setAutoDraw(True)
            elif sceneBorder3.status == STARTED and t >= (0.0 + (6-win.monitorFramePeriod*0.75)): #most of one frame period left
                sceneBorder3.setAutoDraw(False)
            
            # *scenePic3* updates
            if t >= 0.0 and scenePic3.status == NOT_STARTED:
                # keep track of start time/frame for later
                scenePic3.tStart = t  # underestimates by a little under one frame
                scenePic3.frameNStart = frameN  # exact frame index
                scenePic3.setAutoDraw(True)
            elif scenePic3.status == STARTED and t >= (0.0 + (6-win.monitorFramePeriod*0.75)): #most of one frame period left
                scenePic3.setAutoDraw(False)
            
            # *faceBorder1* updates
            if t >= 0.0 and faceBorder1.status == NOT_STARTED:
                # keep track of start time/frame for later
                faceBorder1.tStart = t  # underestimates by a little under one frame
                faceBorder1.frameNStart = frameN  # exact frame index
                faceBorder1.setAutoDraw(True)
            elif faceBorder1.status == STARTED and t >= (0.0 + (6-win.monitorFramePeriod*0.75)): #most of one frame period left
                faceBorder1.setAutoDraw(False)
            
            # *faceBorder2* updates
            if t >= 0.0 and faceBorder2.status == NOT_STARTED:
                # keep track of start time/frame for later
                faceBorder2.tStart = t  # underestimates by a little under one frame
                faceBorder2.frameNStart = frameN  # exact frame index
                faceBorder2.setAutoDraw(True)
            elif faceBorder2.status == STARTED and t >= (0.0 + (6-win.monitorFramePeriod*0.75)): #most of one frame period left
                faceBorder2.setAutoDraw(False)
            
            # *faceBorder3* updates
            if t >= 0.0 and faceBorder3.status == NOT_STARTED:
                # keep track of start time/frame for later
                faceBorder3.tStart = t  # underestimates by a little under one frame
                faceBorder3.frameNStart = frameN  # exact frame index
                faceBorder3.setAutoDraw(True)
            elif faceBorder3.status == STARTED and t >= (0.0 + (6-win.monitorFramePeriod*0.75)): #most of one frame period left
                faceBorder3.setAutoDraw(False)
            
            # *testFace1* updates
            if t >= 0.0 and testFace1.status == NOT_STARTED:
                # keep track of start time/frame for later
                testFace1.tStart = t  # underestimates by a little under one frame
                testFace1.frameNStart = frameN  # exact frame index
                testFace1.setAutoDraw(True)
            elif testFace1.status == STARTED and t >= (0.0 + (6-win.monitorFramePeriod*0.75)): #most of one frame period left
                testFace1.setAutoDraw(False)
            
            # *recogResponse* updates
            if t >= 0 and recogResponse.status == NOT_STARTED:
                # keep track of start time/frame for later
                recogResponse.tStart = t  # underestimates by a little under one frame
                recogResponse.frameNStart = frameN  # exact frame index
                recogResponse.status = STARTED
                # keyboard checking is just starting
                recogResponse.clock.reset()  # now t=0
                event.clearEvents(eventType='keyboard')
            elif recogResponse.status == STARTED and t >= (0 + (6-win.monitorFramePeriod*0.75)): #most of one frame period left
                recogResponse.status = STOPPED
            if recogResponse.status == STARTED:
                theseKeys = event.getKeys(keyList=['1', '2', '3'])
                
                # check for quit:
                if "escape" in theseKeys:
                    endExpNow = True
                if len(theseKeys) > 0:  # at least one key was pressed
                    recogResponse.keys = theseKeys[-1]  # just the last key pressed
                    recogResponse.rt = recogResponse.clock.getTime()
                    # was this 'correct'?
                    if (recogResponse.keys == str(CorrectAns)) or (recogResponse.keys == CorrectAns):
                        recogResponse.corr = 1
                    else:
                        recogResponse.corr = 0
                    # a response ends the routine
                    continueRoutine = True
            
            # *recogQuestion* updates
            if t >= 0 and recogQuestion.status == NOT_STARTED:
                # keep track of start time/frame for later
                recogQuestion.tStart = t  # underestimates by a little under one frame
                recogQuestion.frameNStart = frameN  # exact frame index
                recogQuestion.setAutoDraw(True)
            elif recogQuestion.status == STARTED and t >= (0 + (6-win.monitorFramePeriod*0.75)) or len(theseKeys) > 0: #most of one frame period left
                recogQuestion.setAutoDraw(False)
            
            # *patch* updates
            if t >= 0.0 and patch.status == NOT_STARTED:
                # keep track of start time/frame for later
                patch.tStart = t  # underestimates by a little under one frame
                patch.frameNStart = frameN  # exact frame index
                patch.setAutoDraw(True)
            elif patch.status == STARTED and t >= (0.0 + (6-win.monitorFramePeriod*0.75)): #most of one frame period left
                patch.setAutoDraw(False)
            
            # *patch_2* updates
            if t >= 0.0 and patch_2.status == NOT_STARTED:
                # keep track of start time/frame for later
                patch_2.tStart = t  # underestimates by a little under one frame
                patch_2.frameNStart = frameN  # exact frame index
                patch_2.setAutoDraw(True)
            elif patch_2.status == STARTED and t >= (0.0 + (6-win.monitorFramePeriod*0.75)): #most of one frame period left
                patch_2.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineTimer.reset()  # if we abort early the non-slip timer needs reset
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in Scene_3FacesComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        #-------Ending Routine "Scene_3Faces"-------
        for thisComponent in Scene_3FacesComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # check responses
        if recogResponse.keys in ['', [], None]:  # No response was made
           recogResponse.keys=None
           # was no response the correct answer?!
           if str(CorrectAns).lower() == 'none': recogResponse.corr = 1  # correct non-response
           else: recogResponse.corr = 0  # failed to respond (incorrectly)
        # store data for testTrials (TrialHandler)
        testTrials.addData('recogResponse.keys',recogResponse.keys)
        testTrials.addData('recogResponse.corr', recogResponse.corr)
        if recogResponse.keys != None:  # we had a response
            testTrials.addData('recogResponse.rt', recogResponse.rt)
        
        #------Prepare to start Routine "RCJ"-------
        t = 0
        RCJClock.reset()  # clock 
        frameN = -1
        routineTimer.add(5.000000)

        # update component parameters for each repeat
        # ########################LAS-segregate trials#################
        #iViewXAPI.iV_SendImageMessage(c_char_p(str("Confidence.bmp")))
        
        confResponse = event.BuilderKeyResponse()  # create an object of type KeyResponse
        confResponse.status = NOT_STARTED
        # keep track of which components have finished
        RCJComponents = []
        RCJComponents.append(confRating)
        RCJComponents.append(confResponse)
        for thisComponent in RCJComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        #-------Start Routine "RCJ"-------
        continueRoutine = True
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = RCJClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *confRating* updates
            if t >= 0.0 and confRating.status == NOT_STARTED:
                # keep track of start time/frame for later
                confRating.tStart = t  # underestimates by a little under one frame
                confRating.frameNStart = frameN  # exact frame index
                confRating.setAutoDraw(True)
            elif confRating.status == STARTED and t >= (0.0 + (5-win.monitorFramePeriod*0.75)): #most of one frame period left
                confRating.setAutoDraw(False)
            
            # *confResponse* updates
            if t >= 0.0 and confResponse.status == NOT_STARTED:
                # keep track of start time/frame for later
                confResponse.tStart = t  # underestimates by a little under one frame
                confResponse.frameNStart = frameN  # exact frame index
                confResponse.status = STARTED
                # keyboard checking is just starting
                confResponse.clock.reset()  # now t=0
                event.clearEvents(eventType='keyboard')
            elif confResponse.status == STARTED and t >= (0.0 + (5-win.monitorFramePeriod*0.75)): #most of one frame period left
                confResponse.status = STOPPED
            if confResponse.status == STARTED:
                theseKeys = event.getKeys(keyList=['quoteleft', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0'])
                
                # check for quit:
                if "escape" in theseKeys:
                    endExpNow = True
                if len(theseKeys) > 0:  # at least one key was pressed
                    confResponse.keys = theseKeys[-1]  # just the last key pressed
                    confResponse.rt = confResponse.clock.getTime()
                    # a response ends the routine
                    continueRoutine = False
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineTimer.reset()  # if we abort early the non-slip timer needs reset
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in RCJComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        #-------Ending Routine "RCJ"-------
        for thisComponent in RCJComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # check responses
        if confResponse.keys in ['', [], None]:  # No response was made
           confResponse.keys=None
        # store data for testTrials (TrialHandler)
        testTrials.addData('confResponse.keys',confResponse.keys)
        if confResponse.keys != None:  # we had a response
            testTrials.addData('confResponse.rt', confResponse.rt)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'testTrials'
    #iViewXAPI.iV_PauseRecording()
    #iViewXAPI.iV_SendImageMessage(c_char_p(str("Finished Test Block Pause Recording")))
    
    # get names of stimulus parameters
    if testTrials.trialList in ([], [None], None):  params = []
    else:  params = testTrials.trialList[0].keys()
    # save data for this loop
    testTrials.saveAsExcel(filename + '.xlsx', sheetName='testTrials',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    
    #------Prepare to start Routine "endTestBlock"-------
    t = 0
    endTestBlockClock.reset()  # clock 
    frameN = -1
    # update component parameters for each repeat
    key_resp_6 = event.BuilderKeyResponse()  # create an object of type KeyResponse
    key_resp_6.status = NOT_STARTED
    # keep track of which components have finished
    endTestBlockComponents = []
    endTestBlockComponents.append(text_8)
    endTestBlockComponents.append(key_resp_6)
    for thisComponent in endTestBlockComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    #-------Start Routine "endTestBlock"-------
    continueRoutine = True
    while continueRoutine:
        # get current time
        t = endTestBlockClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text_8* updates
        if t >= 0.0 and text_8.status == NOT_STARTED:
            # keep track of start time/frame for later
            text_8.tStart = t  # underestimates by a little under one frame
            text_8.frameNStart = frameN  # exact frame index
            text_8.setAutoDraw(True)
        
        # *key_resp_6* updates
        if t >= 0.0 and key_resp_6.status == NOT_STARTED:
            # keep track of start time/frame for later
            key_resp_6.tStart = t  # underestimates by a little under one frame
            key_resp_6.frameNStart = frameN  # exact frame index
            key_resp_6.status = STARTED
            # keyboard checking is just starting
            event.clearEvents(eventType='keyboard')
        if key_resp_6.status == STARTED:
            theseKeys = event.getKeys(keyList=['q'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineTimer.reset()  # if we abort early the non-slip timer needs reset
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in endTestBlockComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
        else:  # this Routine was not non-slip safe so reset non-slip timer
            routineTimer.reset()
    
    #-------Ending Routine "endTestBlock"-------
    for thisComponent in endTestBlockComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    thisExp.nextEntry()
    

# completed 1 repeats of 'blockLoop'

# get names of stimulus parameters
if blockLoop.trialList in ([], [None], None):  params = []
else:  params = blockLoop.trialList[0].keys()
# save data for this loop
blockLoop.saveAsExcel(filename + '.xlsx', sheetName='blockLoop',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# ####################################### #
#iViewXAPI.iV_StopRecording()
#participant = expInfo['participant']
#res = iViewXAPI.iV_SaveData(str(filename), 1)
#print 'iV_SaveData ' + str(res)
#print "data saved to: " + outputfile

#iViewXAPI.iV_Disconnect()
#------Prepare to start Routine "end"-------
t = 0
endClock.reset()  # clock 
frameN = -1
# update component parameters for each repeat
key_resp_5 = event.BuilderKeyResponse()  # create an object of type KeyResponse
key_resp_5.status = NOT_STARTED
# keep track of which components have finished
endComponents = []
endComponents.append(text_7)
endComponents.append(key_resp_5)
for thisComponent in endComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

#-------Start Routine "end"-------
continueRoutine = True
while continueRoutine:
    # get current time
    t = endClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_7* updates
    if t >= 0.0 and text_7.status == NOT_STARTED:
        # keep track of start time/frame for later
        text_7.tStart = t  # underestimates by a little under one frame
        text_7.frameNStart = frameN  # exact frame index
        text_7.setAutoDraw(True)
    
    # *key_resp_5* updates
    if t >= 0.0 and key_resp_5.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp_5.tStart = t  # underestimates by a little under one frame
        key_resp_5.frameNStart = frameN  # exact frame index
        key_resp_5.status = STARTED
        # keyboard checking is just starting
        event.clearEvents(eventType='keyboard')
    if key_resp_5.status == STARTED:
        theseKeys = event.getKeys(keyList=['q'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineTimer.reset()  # if we abort early the non-slip timer needs reset
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in endComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()
    else:  # this Routine was not non-slip safe so reset non-slip timer
        routineTimer.reset()

#-------Ending Routine "end"-------
for thisComponent in endComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
win.close()
core.quit()
